/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20170709

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0

#ifndef yyparse
#define yyparse    rrparse
#endif /* yyparse */

#ifndef yylex
#define yylex      rrlex
#endif /* yylex */

#ifndef yyerror
#define yyerror    rrerror
#endif /* yyerror */

#ifndef yychar
#define yychar     rrchar
#endif /* yychar */

#ifndef yyval
#define yyval      rrval
#endif /* yyval */

#ifndef yylval
#define yylval     rrlval
#endif /* yylval */

#ifndef yydebug
#define yydebug    rrdebug
#endif /* yydebug */

#ifndef yynerrs
#define yynerrs    rrnerrs
#endif /* yynerrs */

#ifndef yyerrflag
#define yyerrflag  rrerrflag
#endif /* yyerrflag */

#ifndef yylhs
#define yylhs      rrlhs
#endif /* yylhs */

#ifndef yylen
#define yylen      rrlen
#endif /* yylen */

#ifndef yydefred
#define yydefred   rrdefred
#endif /* yydefred */

#ifndef yydgoto
#define yydgoto    rrdgoto
#endif /* yydgoto */

#ifndef yysindex
#define yysindex   rrsindex
#endif /* yysindex */

#ifndef yyrindex
#define yyrindex   rrrindex
#endif /* yyrindex */

#ifndef yygindex
#define yygindex   rrgindex
#endif /* yygindex */

#ifndef yytable
#define yytable    rrtable
#endif /* yytable */

#ifndef yycheck
#define yycheck    rrcheck
#endif /* yycheck */

#ifndef yyname
#define yyname     rrname
#endif /* yyname */

#ifndef yyrule
#define yyrule     rrrule
#endif /* yyrule */
#define YYPREFIX "rr"

#define YYPURE 0

/*
 * Grammar for reporters catalog
 *
 * Copyright (C) International Business Machines Corp., 2009
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#define CATALOGS_IMPLEMENTATION
#include <malloc.h>
#include "catalogs.h"

extern ReporterCtlgParser reporter_ctlg_parser;
static ReporterCtlgParser *pc = &reporter_ctlg_parser;
extern ReporterCatalog reporter_catalog;
static Reporter *reporter;
static MetaReporter *meta_reporter;
static vector<string> *name_list;
static vector<ReporterAlias*> *alias_list;

/* Why doesn't yacc declare this? */
extern int yylex(void);
void yyerror(const char *s);

#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
typedef union {
	int		ival;	/* keyword, punctuation */
	char		*sval;	/* string, name */
	Reporter	*reporter;
	MetaReporter	*meta_reporter;
	vector<string>	*name_list;
	ReporterAlias	*alias;
	vector<ReporterAlias*> *alias_list;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define KW_ALIASES 257
#define KW_META_REPORTER 258
#define KW_PREFIX_ARGS 259
#define KW_PREFIX_FORMAT 260
#define KW_REPORTER 261
#define KW_SOURCE 262
#define KW_VARIANTS 263
#define KW_DEVICE_ARG 264
#define TK_STRING 265
#define TK_NAME 266
#define ERRTOK 267
#define YYERRCODE 256
typedef short YYINT;
static const YYINT rrlhs[] = {                           -1,
    0,    0,    9,    9,    9,    1,    3,    4,   14,    2,
    5,    6,    6,    7,    7,    8,    8,   10,   10,   11,
   11,   12,   12,   13,   13,
};
static const YYINT rrlen[] = {                            2,
    1,    2,    1,    1,    1,    6,    2,    3,    3,    3,
    3,    1,    2,    1,    4,    1,    2,    3,    0,    3,
    0,    3,    0,    3,    0,
};
static const YYINT rrdefred[] = {                         0,
    5,    0,    0,    0,    3,    0,    4,    0,    1,    0,
    0,    2,    0,    0,    0,    7,    8,    0,   10,    0,
    0,    0,    0,    0,   11,    0,    0,    0,   12,    0,
    0,   16,    0,    0,    0,    0,   13,   15,   17,   20,
    0,    0,    6,    0,    0,   24,
};
static const YYINT rrdgoto[] = {                          4,
    5,    6,    7,    8,   14,   30,   19,   33,    9,   22,
   28,   36,   43,   16,
};
static const YYINT rrsindex[] = {                      -253,
    0,  -56,  -54, -253,    0, -256,    0, -254,    0, -255,
 -252,    0,  -46, -244,  -43,    0,    0,  -24,    0, -248,
  -39, -240, -245, -243,    0, -252,  -36, -234,    0, -239,
  -15,    0, -252, -236,  -28, -233,    0,    0,    0,    0,
 -245,  -25,    0, -239, -232,    0,
};
static const YYINT rrrindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   10,    0,    0,    0,    1,    0,    0,
    0,   24,    0,    0,    0,    0,    0,   28,    0,   39,
    0,    0,   17,    0,    0,   45,    0,    0,    0,    0,
    0,    0,    0,   35,    0,    0,
};
static const YYINT rrgindex[] = {                         0,
    0,    0,    0,    0,    0,   -9,  -26,    0,   32,    0,
    0,    0,    0,    0,
};
#define YYTABLESIZE 306
static const YYINT rrtable[] = {                         32,
   14,   10,    1,   11,    2,   13,   39,    3,   15,   19,
   17,   20,   21,   18,   23,   24,   18,   25,   26,   27,
   29,   34,   31,   21,   35,   38,   37,   23,   40,   41,
   42,   44,   45,   46,   22,   12,    0,    0,    9,    0,
    0,    0,    0,    0,   25,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   14,    0,   14,   14,
   14,   14,   14,    0,   14,   19,   14,   19,   19,   19,
   19,    0,   18,   19,   18,   18,   18,   18,    0,   21,
   18,   21,   21,   23,   21,   23,    0,   21,   23,    0,
   22,   23,   22,    0,    9,   22,    9,    0,   22,    9,
   25,    0,   25,    0,    0,   25,
};
static const YYINT rrcheck[] = {                         26,
    0,   58,  256,   58,  258,  262,   33,  261,  263,    0,
  266,   58,  257,  266,   58,   40,    0,  266,   58,  260,
  266,   58,  266,    0,  259,   41,  266,    0,  265,   58,
  264,   41,   58,  266,    0,    4,   -1,   -1,    0,   -1,
   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,  258,  259,
  260,  261,  262,   -1,  264,  256,  266,  258,  259,  260,
  261,   -1,  256,  264,  258,  259,  260,  261,   -1,  256,
  264,  258,  259,  256,  261,  258,   -1,  264,  261,   -1,
  256,  264,  258,   -1,  256,  261,  258,   -1,  264,  261,
  256,   -1,  258,   -1,   -1,  261,
};
#define YYFINAL 4
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 267
#define YYUNDFTOKEN 284
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const rrname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"':'",0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"KW_ALIASES",
"KW_META_REPORTER","KW_PREFIX_ARGS","KW_PREFIX_FORMAT","KW_REPORTER",
"KW_SOURCE","KW_VARIANTS","KW_DEVICE_ARG","TK_STRING","TK_NAME","ERRTOK",0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,"illegal-symbol",
};
static const char *const rrrule[] = {
"$accept : catalog",
"catalog : entry",
"catalog : catalog entry",
"entry : reporter_entry",
"entry : meta_reporter_entry",
"entry : error",
"reporter_entry : reporter_stmt source_stmt aliases_stmt prefix_format_stmt prefix_args_stmt device_arg_stmt",
"meta_reporter_entry : meta_reporter_stmt variants_stmt",
"meta_reporter_stmt : KW_META_REPORTER ':' TK_NAME",
"variants_stmt : KW_VARIANTS ':' name_list",
"reporter_stmt : KW_REPORTER ':' name_and_lvl",
"source_stmt : KW_SOURCE ':' TK_NAME",
"name_list : TK_NAME",
"name_list : name_list TK_NAME",
"name_and_lvl : TK_NAME",
"name_and_lvl : TK_NAME '(' TK_NAME ')'",
"alias_list : name_and_lvl",
"alias_list : alias_list name_and_lvl",
"aliases_stmt : KW_ALIASES ':' alias_list",
"aliases_stmt :",
"prefix_format_stmt : KW_PREFIX_FORMAT ':' TK_STRING",
"prefix_format_stmt :",
"prefix_args_stmt : KW_PREFIX_ARGS ':' name_list",
"prefix_args_stmt :",
"device_arg_stmt : KW_DEVICE_ARG ':' TK_NAME",
"device_arg_stmt :",

};
#endif

int      yydebug;
int      yynerrs;

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;

/* AKA rrerror() */
void yyerror(const char *s)
{
	fprintf(stderr, "%s:%d: %s\n", pc->pathname, pc->lineno, s);
}

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yym = 0;
    yyn = 0;
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        yychar = YYLEX;
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);

    switch (yyn)
    {
case 3:
	{
				reporter_catalog.register_reporter(yystack.l_mark[0].reporter);
			}
break;
case 4:
	{
				reporter_catalog.register_meta_reporter(yystack.l_mark[0].meta_reporter);
			}
break;
case 6:
	{ yyval.reporter = yystack.l_mark[-5].reporter; }
break;
case 7:
	{ yyval.meta_reporter = yystack.l_mark[-1].meta_reporter; }
break;
case 8:
	{
				meta_reporter = new MetaReporter(yystack.l_mark[0].sval);
				free(yystack.l_mark[0].sval);
				yyval.meta_reporter = meta_reporter;
			}
break;
case 9:
	{
				meta_reporter->set_variant_names(yystack.l_mark[0].name_list);
			}
break;
case 10:
	{ 
				reporter = new Reporter(yystack.l_mark[0].alias);
				yyval.reporter = reporter;
			}
break;
case 11:
	{
				reporter->set_source(yystack.l_mark[0].sval);
				free(yystack.l_mark[0].sval);
			}
break;
case 12:
	{ 
				name_list = new vector<string>();
				name_list->push_back(yystack.l_mark[0].sval);
				yyval.name_list = name_list;
				free(yystack.l_mark[0].sval);
			}
break;
case 13:
	{
				name_list->push_back(yystack.l_mark[0].sval); 
				yyval.name_list = name_list;
				free(yystack.l_mark[0].sval);
			}
break;
case 14:
	{
				yyval.alias = new ReporterAlias(yystack.l_mark[0].sval);
				free(yystack.l_mark[0].sval);
			}
break;
case 15:
	{
				yyval.alias = new ReporterAlias(yystack.l_mark[-3].sval, yystack.l_mark[-1].sval);
				free(yystack.l_mark[-3].sval);
				free(yystack.l_mark[-1].sval);
			}
break;
case 16:
	{
				alias_list = new vector<ReporterAlias*>();
				alias_list->push_back(yystack.l_mark[0].alias);
				yyval.alias_list = alias_list;
			}
break;
case 17:
	{
				alias_list->push_back(yystack.l_mark[0].alias); 
				yyval.alias_list = alias_list;
			}
break;
case 18:
	{ reporter->set_aliases(yystack.l_mark[0].alias_list); }
break;
case 20:
	{
				reporter->set_prefix_format(yystack.l_mark[0].sval);
				free(yystack.l_mark[0].sval);
			}
break;
case 22:
	{
				reporter->set_prefix_args(yystack.l_mark[0].name_list);
			}
break;
case 24:
	{
				reporter->set_device_arg(yystack.l_mark[0].sval);
				free(yystack.l_mark[0].sval);
			}
break;
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            yychar = YYLEX;
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
